jjb: fix multiples kernel build failures
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
51fa2ab3 35 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
36}
37
38vergte() {
51fa2ab3 39 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
40}
41
42vergt() {
51fa2ab3 43 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
44}
45
339db64d 46
5a196804
MJ
47git_clone_modules_sources() {
48 mkdir -p "$MODULES_GIT_DIR"
49 git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
50}
51
52# Checkout a shallow kernel tree of the specified tag
53git_clone_linux_sources() {
54 mkdir -p "$LINUX_GIT_DIR"
55 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
56}
7e02032c 57
7e02032c 58
5a196804
MJ
59# Export the kernel sources from the git repo
60git_export_linux_sources() {
61 cd "$LINUX_GIT_DIR"
62 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
63}
64
65
66# Upload the tar archive to the object store
67upload_archive_obj() {
68 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
69 rm -f "$WORKSPACE/$obj_name"
70}
71
72
73extract_archive_obj() {
74 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
75 rm -f "$WORKSPACE/$obj_name"
76}
77
78
79tar_archive_obj() {
80 cd "$LINUX_OBJ_DIR"
81 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
82 cd -
83}
84
85# Find the most recent GCC version supported by the kernel sources
86select_compiler() {
87 local selected_cc
88
89 cd "$LINUX_SRCOBJ_DIR"
90
91 kversion=$(make -s kernelversion)
92
93 set +e
94
1d5a0a3c 95 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
96 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
97 selected_cc="$cc"
98 break
99 fi
100 done
101
102 set -e
103
104 if [ "x$selected_cc" = "x" ]; then
105 echo "Found no suitable compiler."
106 exit 1
107 fi
108
1d5a0a3c
MJ
109 # Force gcc-4.8 for kernels before 3.18
110 if { verlt "$kversion" "3.18"; }; then
23db2292 111 selected_cc=gcc-4.8
7e02032c
MJ
112 fi
113
425e4992
MJ
114 if [ "$selected_cc" != "gcc-4.8" ]; then
115 # Older kernel Makefiles do not expect the compiler to default to PIE
116 KAFLAGS="-fno-pie"
c45b04df 117 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
118 KCPPFLAGS="-fno-pie"
119 export KAFLAGS KCFLAGS KCPPFLAGS
120 fi
121
5a196804 122 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 123 export HOSTCC="${selected_cc}"
5a196804
MJ
124
125 cd -
126}
127
128
129build_linux_kernel() {
130 cd "$LINUX_SRCOBJ_DIR"
131
132 kversion=$(make -s kernelversion)
133
7e02032c 134 # Generate kernel configuration
a1ae361e 135 case "$ktag" in
7e02032c 136 Ubuntu*)
39961776 137 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 138 if vergte "${kversion}" "4.10"; then
39961776
MJ
139 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
140 exit 0
141 fi
142 fi
a46abb0a
MJ
143 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
144 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 145 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 146 ;;
c45b04df 147
7e02032c 148 *)
16844a6d
MJ
149 # Force 32bit build on i386, default is 64bit
150 if [ "$arch" = "i386" ]; then
5a196804
MJ
151 export ARCH="i386"
152 fi
153
154 # allyesconfig is mostly broken for kernels of the 2.6 series
155 if verlt "$kversion" "3.0"; then
156 vanilla_config="defconfig"
7a76a4d0
MJ
157 fi
158
5a196804 159 make "${vanilla_config}"
7e02032c
MJ
160 ;;
161 esac
162
5a196804
MJ
163 # silentoldconfig was renamed in 4.19
164 if vergte "$kversion" "4.19"; then
165 update_conf_target="syncconfig"
166 else
167 update_conf_target="silentoldconfig"
168 fi
169
170 # Fix 'defined(@array)' was removed from recent perl
171 if [ -f "kernel/timeconst.pl" ]; then
172 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
173 fi
174
175 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
23db2292 176 if [ "$CC" != "gcc-4.8" ]; then
5a196804
MJ
177 if [ -f "arch/x86/kvm/svm.c" ]; then
178 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
179 fi
180
181 if [ -f "arch/x86/kvm/vmx.c" ]; then
182 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
183 fi
184 fi
185
186 # Fix a typo in v2.6.36.x
187 if [ -f "arch/x86/kernel/entry_64.S" ]; then
188 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
189 fi
190
191 # Fix kernel < 3.0 with gcc >= 4.7
192 if verlt "$kversion" "3.0"; then
193 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
194 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
195 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
196 echo "header-y += linkage.h" >> include/linux/Kbuild
197 fi
198
7e02032c 199 # GCC 4.8
5a196804 200 sed -i "s/CONFIG_CC_STACKPROTECTOR_STRONG=y/# CONFIG_CC_STACKPROTECTOR_STRONG is not set/g" .config
7e02032c
MJ
201
202 # Don't try to sign modules
5a196804 203 sed -i "s/CONFIG_MODULE_SIG=y/# CONFIG_MODULE_SIG is not set/g" .config
7e02032c 204
9ef18fa2 205 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
5a196804
MJ
206 sed -i "s/CONFIG_STACK_VALIDATION=y/# CONFIG_STACK_VALIDATION is not set/g" .config
207
208 # Cause problems with inline assembly on i386
209 sed -i "s/CONFIG_DEBUG_SECTION_MISMATCH=y/# CONFIG_DEBUG_SECTION_MISMATCH is not set/g" .config
210
1d5a0a3c
MJ
211 # Don't build samples, they are broken on some kernel releases
212 sed -i "s/CONFIG_SAMPLES=y/# CONFIG_SAMPLES is not set/g" .config
c45b04df
MJ
213 sed -i "s/CONFIG_BUILD_DOCSRC=y/# CONFIG_BUILD_DOCSRC is not set/g" .config
214
215 # Disable kcov
216 sed -i "s/CONFIG_KCOV=y/# CONFIG_KCOV is not set/g" .config
217
218 # Broken on some RT kernels
219 sed -i "s/CONFIG_HYPERV=y/# CONFIG_HYPERV is not set/g" .config
1d5a0a3c 220
5a196804
MJ
221 # IGBVF won't build with recent gcc on 2.6.38.x
222 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
223 sed -i "s/CONFIG_IGBVF=y/# CONFIG_IGBVF is not set/g" .config
224 fi
9ef18fa2 225
51fa2ab3 226 # Set required options
c45b04df
MJ
227 sed -i 's/# CONFIG_KPROBES is not set/CONFIG_KPROBES=y/g' .config
228 sed -i 's/# CONFIG_FTRACE is not set/CONFIG_FTRACE=y/g' .config
229 sed -i 's/# CONFIG_BLK_DEV_IO_TRACE is not set/CONFIG_BLK_DEV_IO_TRACE=y/g' .config
230 sed -i 's/# CONFIG_KALLSYMS_ALL is not set/CONFIG_KALLSYMS_ALL=y/g' .config
7e02032c 231
7a76a4d0 232 # Debug
5a196804
MJ
233 #cat .config
234
235 make "$update_conf_target" CC="$CC"
236 make -j"$NPROC" CC="$CC"
237
c45b04df 238 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
239
240 # Save the kernel and modules
241 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
242 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install
243 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install
244 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
245 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
246 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
247}
248
249
250extract_distro_headers() {
251
252 # Enter linux source dir
253 cd "${LINUX_SRCOBJ_DIR}"
254
255
256 # For RT kernels, copy version file
257 if [ -s localversion-rt ]; then
258 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
259 fi
260
261 # Copy all Makefile related stuff
262 find . -path './include/*' -prune \
263 -o -path './scripts/*' -prune -o -type f \
264 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
265 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
266 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
267
268 # Copy base scripts and include dirs
269 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 270
5a196804
MJ
271 # Copy arch includes
272 (find arch -name include -type d -print0 | \
273 xargs -0 -n1 -i: find : -type f) | \
274 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
275
276 # Copy arch scripts
277 (find arch -name scripts -type d -print0 | \
278 xargs -0 -n1 -i: find : -type f) | \
279 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
280
281 # Cleanup scripts
282 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
283 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
284
285 # On powerpc this object is required to link modules
286 if [ "${karch}" = "powerpc" ]; then
287 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
288 fi
289
290 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
291 if [ "${karch}" = "arm64" ]; then
292 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
293 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
294 fi
295 fi
296
297 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
298 if [ -f tools/objtool/objtool ]; then
299 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
300 fi
301
302 if [ -f "arch/x86/kernel/macros.s" ]; then
303 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
304 fi
305
306 # Copy modules related stuff, if available
307 if [ -s Module.symvers ]; then
308 cp Module.symvers "${LINUX_HDROBJ_DIR}"
309 fi
310
311 if [ -s System.map ]; then
312 cp System.map "${LINUX_HDROBJ_DIR}"
313 fi
314
315 if [ -s Module.markers ]; then
316 cp Module.markers "${LINUX_HDROBJ_DIR}"
317 fi
318
319 # Copy config file
320 cp .config "${LINUX_HDROBJ_DIR}"
321
322 # Make sure the Makefile and version.h have a matching timestamp so that
323 # external modules can be built
324 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
325 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
326 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
327 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
328 else
329 echo "Missing version.h"
330 exit 1
331 fi
332 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
333
334 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
335 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
336
337 # Finally clean the object files from the full source tree
338 make clean
339
340 # And regen the modules support files
341 make modules_prepare CC="$CC"
51fa2ab3 342
d815b018
MJ
343 # On powerpc this object is required to link modules
344 if [ "${karch}" = "powerpc" ]; then
5a196804 345 make arch/powerpc/lib/crtsavres.o CC="$CC"
d815b018
MJ
346 fi
347
7a76a4d0 348 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 349 if [ "${karch}" = "arm64" ]; then
c236528e 350 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 351 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
352 fi
353 fi
354
7e02032c 355 # Version specific tasks
a1ae361e 356 case "$ktag" in
7e02032c
MJ
357 Ubuntu*)
358 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 359 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
360 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
361 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
362 ;;
363 esac
7e02032c
MJ
364}
365
366
339db64d
MJ
367build_modules() {
368
5a196804
MJ
369 local kdir="$1"
370 local outdir="$2"
371 local kversion
372
373 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 374
339db64d 375 # Enter lttng-modules source dir
5a196804 376 cd "${MODULES_GIT_DIR}"
339db64d
MJ
377
378 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
379 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
380 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
381 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
382
383 set +e
384
385 # Build modules
51fa2ab3 386 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d 387
5a196804
MJ
388 set -e
389
339db64d
MJ
390 # We expect this build to fail, if it doesn't, fail the job.
391 if [ "$?" -eq 0 ]; then
e9b44189 392 echo "This build should have failed."
339db64d
MJ
393 exit 1
394 fi
395
396 # We have to publish at least one file or the build will fail
5a196804 397 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d
MJ
398
399 set -e
400
5a196804 401 KERNELDIR="${kdir}" make clean
7e02032c 402
339db64d
MJ
403 else # Regular build
404
405 # Build modules against full kernel sources
51fa2ab3 406 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
407
408 # Install modules to build dir
5a196804 409 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
410
411 # Clean build dir
5a196804 412 KERNELDIR="${kdir}" make clean
339db64d
MJ
413 fi
414}
415
416
417## MAIN ##
418
f3d8604b
MJ
419# Use all CPU cores
420NPROC=$(nproc)
421
5a196804
MJ
422MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
423LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 424
5a196804
MJ
425LINUX_OBJ_DIR="${WORKSPACE}/linux"
426LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
427LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
428LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 429
5a196804
MJ
430MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
431MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 432
5a196804
MJ
433LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
434
435OBJ_STORE_URL="s3://jenkins"
436
437cd "$WORKSPACE"
438
439# Create build directories
440mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
441
442git_clone_modules_sources
339db64d 443
7e02032c 444# Setup cross compile env if available
39961776 445if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
446
447 case "$cross_arch" in
448 "armhf")
449 karch="arm"
450 cross_compile="arm-linux-gnueabihf-"
e9b44189 451 vanilla_config="allyesconfig"
7e02032c
MJ
452 ubuntu_config="armhf-config.flavour.generic"
453 ;;
454
455 "arm64")
456 karch="arm64"
457 cross_compile="aarch64-linux-gnu-"
e9b44189 458 vanilla_config="allyesconfig"
7e02032c
MJ
459 ubuntu_config="arm64-config.flavour.generic"
460 ;;
461
462 "powerpc")
463 karch="powerpc"
464 cross_compile="powerpc-linux-gnu-"
e9b44189 465 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
466 ubuntu_config="powerpc-config.flavour.powerpc-smp"
467 ;;
468
469 "ppc64el")
470 karch="powerpc"
471 cross_compile="powerpc64le-linux-gnu-"
e9b44189 472 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
473 ubuntu_config="ppc64el-config.flavour.generic"
474 ;;
475
476 *)
51fa2ab3 477 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
478 exit 1
479 ;;
480 esac
339db64d 481
7e02032c
MJ
482 # Export variables used by Kbuild for cross compilation
483 export ARCH="${karch}"
484 export CROSS_COMPILE="${cross_compile}"
339db64d 485
7e02032c 486# Set arch specific values if we are not cross compiling
39961776 487elif [ "x${arch}" != "x" ]; then
e9b44189 488
7e02032c 489 case "$arch" in
16844a6d 490 "i386")
7e02032c 491 karch="x86"
e9b44189 492 vanilla_config="allyesconfig"
7e02032c
MJ
493 ubuntu_config="i386-config.flavour.generic"
494 ;;
495
16844a6d 496 "amd64")
7e02032c 497 karch="x86"
e9b44189 498 vanilla_config="allyesconfig"
7e02032c
MJ
499 ubuntu_config="amd64-config.flavour.generic"
500 ;;
501
502 "armhf")
503 karch="arm"
e9b44189 504 vanilla_config="allyesconfig"
7e02032c
MJ
505 ubuntu_config="armhf-config.flavour.generic"
506 ;;
507
508 "arm64")
509 karch="arm64"
e9b44189 510 vanilla_config="allyesconfig"
7e02032c
MJ
511 ubuntu_config="arm64-config.flavour.generic"
512 ;;
513
514 "powerpc")
515 karch="powerpc"
e9b44189 516 vanilla_config="allyesconfig"
7e02032c
MJ
517 ubuntu_config="powerpc-config.flavour.powerpc-smp"
518 ;;
519
520 "ppc64el")
521 karch="powerpc"
e9b44189 522 vanilla_config="allyesconfig"
7e02032c
MJ
523 ubuntu_config="ppc64el-config.flavour.generic"
524 ;;
525
526 *)
527 echo "Unsupported arch $arch"
528 exit 1
529 ;;
530 esac
531else
532 echo "Not arch or cross_arch specified"
533 exit 1
534fi
339db64d 535
339db64d 536
b214d997 537
5a196804
MJ
538# First get the kernel build from the object store, or build it, if it's
539# not available.
339db64d 540
5a196804
MJ
541echo "# Setup endpoint
542host_base = obj.internal.efficios.com
543host_bucket = obj.internal.efficios.com
544bucket_location = us-east-1
545use_https = True
7e02032c 546
5a196804
MJ
547# Setup access keys
548access_key = jenkins
549secret_key = echo123456
339db64d 550
5a196804
MJ
551# Enable S3 v4 signature APIs
552signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 553
c45b04df 554url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 555obj_name="linux.tar.bz2"
c45b04df 556obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
5a196804 557obj_url="$obj_url_prefix/$obj_name"
339db64d 558
5a196804
MJ
559set +e
560s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
561ret=$?
562set -e
339db64d 563
5a196804
MJ
564case "$ret" in
565 "0")
566 extract_archive_obj
567 ;;
a1ae361e 568
5a196804
MJ
569 "12")
570 echo "File not found"
339db64d 571
5a196804
MJ
572 # Build all the things and upload
573 # then finish the module build...
339db64d 574
5a196804
MJ
575 git_clone_linux_sources
576 git_export_linux_sources
339db64d 577
5a196804 578 select_compiler
a1ae361e 579
5a196804
MJ
580 ## PREPARE FULL LINUX SOURCE TREE
581 build_linux_kernel
d138fc44 582
5a196804
MJ
583 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
584 extract_distro_headers
339db64d 585
5a196804 586 tar_archive_obj
339db64d 587
5a196804 588 upload_archive_obj
339db64d 589
5a196804 590 ;;
339db64d 591
5a196804
MJ
592 *)
593 echo "Unknown error? Abort"
594 exit 1
595 ;;
596esac
339db64d 597
5a196804 598select_compiler
f3d8604b 599
7e02032c 600## BUILD modules
5a196804
MJ
601# Either we downloaded a pre-build kernel or we built it and uploaded
602# the archive for future builds.
603
604cd "$WORKSPACE"
f3d8604b 605
339db64d 606# Build modules against full kernel sources
5a196804 607build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 608
339db64d 609# Build modules against kernel headers
5a196804 610build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 611
5a196804
MJ
612# Make sure some modules were actually built
613tree "${MODULES_OUTPUT_KSRC_DIR}"
614if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
615 echo "No modules built!"
616 exit 1
617fi
618
5a196804
MJ
619tree "${MODULES_OUTPUT_KHDR_DIR}"
620if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
621 echo "No modules built!"
622 exit 1
623fi
b214d997 624
f3d8604b 625# EOF
This page took 0.052673 seconds and 4 git commands to generate.